/* Use the obj_password.p to validate a password and to generate a password */

{objmgr.i NEW}

DEFINE VARIABLE cPassWord AS CHARACTER NO-UNDO.
DEFINE VARIABLE cErrCode AS CHARACTER NO-UNDO.
DEFINE VARIABLE cErrMsg AS CHARACTER NO-UNDO.
DEFINE VARIABLE cErrMethod AS CHARACTER NO-UNDO.

OUTPUT TO /tmp/tst_obj_password.log.

RUN OMAdd("Test", "obj_passwd.p").

/* To short */

ASSIGN cPassword = "abc".
RUN ValidatePassword IN OMGH("Test") (cPassword).
RUN GetError IN OMGH("Test") (OUTPUT cErrCode, OUTPUT cErrMsg, OUTPUT cErrMethod).
PUT UNFORMATTED "cPassword: " cPassword SKIP
                "cErrCode: " cErrCode SKIP
                "cErrMsg: " cErrMsg SKIP
                "cErrMethod: " cErrMethod SKIP(2).

/* Not enough numbers */

ASSIGN cPassword = "abcdefghi".
RUN ValidatePassword IN OMGH("Test") (cPassword).
RUN GetError IN OMGH("Test") (OUTPUT cErrCode, OUTPUT cErrMsg, OUTPUT cErrMethod).
PUT UNFORMATTED "cPassword: " cPassword SKIP
                "cErrCode: " cErrCode SKIP
                "cErrMsg: " cErrMsg SKIP
                "cErrMethod: " cErrMethod SKIP(2).
                
/* Not enough letters */

ASSIGN cPassword = "01234567".
RUN ValidatePassword IN OMGH("Test") (cPassword).
RUN GetError IN OMGH("Test") (OUTPUT cErrCode, OUTPUT cErrMsg, OUTPUT cErrMethod).
PUT UNFORMATTED "cPassword: " cPassword SKIP
                "cErrCode: " cErrCode SKIP
                "cErrMsg: " cErrMsg SKIP
                "cErrMethod: " cErrMethod SKIP(2).
                
/* Not ecnough punctuation */

ASSIGN cPassword = "a4s5d6f7ghi".
RUN ValidatePassword IN OMGH("Test") (cPassword).
RUN GetError IN OMGH("Test") (OUTPUT cErrCode, OUTPUT cErrMsg, OUTPUT cErrMethod).
PUT UNFORMATTED "cPassword: " cPassword SKIP
                "cErrCode: " cErrCode SKIP
                "cErrMsg: " cErrMsg SKIP
                "cErrMethod: " cErrMethod SKIP(2).

/* Should be just fine */

ASSIGN cPassword = "a1-d5f6b7ef".
RUN ValidatePassword IN OMGH("Test") (cPassword).
RUN GetError IN OMGH("Test") (OUTPUT cErrCode, OUTPUT cErrMsg, OUTPUT cErrMethod).
PUT UNFORMATTED "cPassword: " cPassword SKIP
                "cErrCode: " cErrCode SKIP
                "cErrMsg: " cErrMsg SKIP
                "cErrMethod: " cErrMethod SKIP(2).

/* Generate a password */

RUN GeneratePassword IN OMGH("Test") (OUTPUT cPassword).
PUT UNFORMATTED "Password From Argument: " cPassword SKIP.

RUN GetAttr IN OMGH("Test") ("Password", OUTPUT cPassword).
PUT UNFORMATTED "Password From Attribute: " cPassword SKIP.

RUN GetError IN OMGH("Test") (OUTPUT cErrCode, OUTPUT cErrMsg, OUTPUT cErrMethod).
PUT UNFORMATTED "cErrCode: " cErrCode SKIP
                "cErrMsg: " cErrMsg SKIP
                "cErrMethod: " cErrMethod SKIP(2).

/* Generate a password again to make sure we don't get the same one again */

RUN GeneratePassword IN OMGH("Test") (OUTPUT cPassword).
PUT UNFORMATTED "Password From Argument: " cPassword SKIP.

RUN GetAttr IN OMGH("Test") ("Password", OUTPUT cPassword).
PUT UNFORMATTED "Password From Attribute: " cPassword SKIP.

RUN GetError IN OMGH("Test") (OUTPUT cErrCode, OUTPUT cErrMsg, OUTPUT cErrMethod).
PUT UNFORMATTED "cErrCode: " cErrCode SKIP
                "cErrMsg: " cErrMsg SKIP
                "cErrMethod: " cErrMethod SKIP(2).


RUN OMDel ("Test").

OUTPUT CLOSE.

